<template>
  <figure class="playCard" v-on:click="onCardClick($event)">
    <section class="playCard__inner" v-if="isReady">
      <section class="playCard__cover" v-bind:style="{ backgroundImage: 'url(' + item.image + ')' }"></section>
      <figcaption class="playCard__meta">
        <section class="playCard__title">{{item.header}}</section>
        <section class="playCard__artist" v-if="item.artist">
          <img v-bind:src="item.artist.image" class="playCard__artist__picture">
          <section class="playCard__artist__name">{{item.artist.name}}</section>
        </section>
      </figcaption>
    </section>
  </figure>
</template>

<script>
import Vue from 'vue';
import Component from 'vue-class-component';

@Component({
  props: {
    type: String,
    item: Object,
  },
})
export default class PlayCard extends Vue {
  get isReady() {
    return Boolean(this.$props.item && this.$props.item.image && this.$props.item.header);
  }

  onCardClick() {
    if (!this.isReady) {
      return;
    }
    this.$emit('onCardClick', {
      type: this.type,
      id: this.id,
    });
  }
}
</script>

<style lang="stylus">
.playCard
  position relative
  width 160px
  min-height 230px
  display flex
  flex-direction column
  margin 10px 8px 14px 8px
  overflow hidden
  border-radius 4px
  box-shadow 0 0 3px rgba(0,0,0,.05)
  background-color #1c212c
  cursor pointer
  &:hover
    box-shadow 0 0 8px rgba(0,0,0,.4)

  &__inner
    display flex
    flex-direction column
    flex 1
    width 100%

  &__cover
    position relative
    width 100%
    height 160px
    flex none
    background-size cover
    background-position center
    background-repeat no-repeat
    
  &__meta
    flex 1
    display flex
    flex-direction column
    min-height 68px
  
  &__title
    display flex
    flex 1
    justify-content center
    align-items center
    max-height 50px
    margin-top auto
    margin-bottom auto
    padding 20px 0
    text-align center
    font-size 14px
    line-height 1.4
    font-weight bold
    font-family 'Encode Sans', sans-serif

  
  &__artist
    display flex
    height 46px
    margin-top auto
    padding 8px
    align-items center

    &__picture
      width 34px
      height 34px
      margin-right 12px
      border-radius 50%
      overflow hidden

    &__name
      flex 1
      min-width 0
      color #565c69
      font-size 12px
      line-height 1.2
      font-weight 700
</style>
